﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TechNote54_SmartIO_PWM_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // IEC667, IEC1000-Series  설정가능한 주파수 배열
        private string[] m_Frequence = { "1K", "2K", "5K", "10K", "20K", "50K", "100K", "200K", "500K", "1M", "2M", "8M", "11M", "16M" };
        // PWM2의 듀티비 설정 변수선언
        private double m_dbPWM2DutyRate;
        // PWM1의 듀티비 설정 변수선언
        private double m_dbPWM1DutyRate;

        private void Form1_Load(object sender, EventArgs e)
        {
            // 현재 Form을 MainForm으로 설정합니다.
            smartForm1.MainForm = this;
            
            // 멤버변수 초기화
            m_dbPWM1DutyRate = 0;
            m_dbPWM2DutyRate = 96.3;

            smartUpDown1.Items = m_Frequence.ToList();

            // PWM1, PWM2 초기 프리스케일러 설정
            smartPWM1.PreScaler = 240;

            // PWM1, PWM2 초기 디바이더 설정
            smartPWM1.ClockDivider1 = SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2;
            smartPWM1.ClockDivider2 = SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE4;

            // PWM출력 비반전 처리
            smartPWM1.Polarity1 = SmartX.SmartPWM.POLARITY.HIGHACTIVE;
            smartPWM1.Polarity2 = SmartX.SmartPWM.POLARITY.HIGHACTIVE;

            // PWM1, PWM2 Counter 초기 값 설정
            smartPWM1.PWMCounter1 = 200;
            smartPWM1.PWMCounter2 = 1381;

            // PWM1, PWM2 듀디비 초기 값 표시 및 설정
            labPwm1Duty.Text = m_dbPWM1DutyRate.ToString();
            smartPWM1.DutyRate1 = m_dbPWM1DutyRate;
            smartPWM1.DutyRate2 = m_dbPWM2DutyRate;

            // PWM1 & PWM2 DeadTime 초기 값 표시 및 설정                         
            smartPWM1.DeadTime = 0;

            // Pwm1 gauge 이미지를 내부 리스트에 추가한다.
            smartPictureBox1.AddImageList(Resource1.Lv0);
            smartPictureBox1.AddImageList(Resource1.Lv1);
            smartPictureBox1.AddImageList(Resource1.Lv2);
            smartPictureBox1.AddImageList(Resource1.Lv3);
            smartPictureBox1.AddImageList(Resource1.Lv4);
            smartPictureBox1.AddImageList(Resource1.Lv5);

            // SmartPictureBox1에 Lv0 이미지를 표시
            smartPictureBox1.DrawNext(0);

            // Pwm2 Servo 각도이미지를 내부 리스트에 추가
            smartPictureBox2.AddImageList(Resource1.Servo0);
            smartPictureBox2.AddImageList(Resource1.Servo10);
            smartPictureBox2.AddImageList(Resource1.Servo20);
            smartPictureBox2.AddImageList(Resource1.Servo30);
            smartPictureBox2.AddImageList(Resource1.Servo40);
            smartPictureBox2.AddImageList(Resource1.Servo50);
            smartPictureBox2.AddImageList(Resource1.Servo60);
            smartPictureBox2.AddImageList(Resource1.Servo70);
            smartPictureBox2.AddImageList(Resource1.Servo80);
            smartPictureBox2.AddImageList(Resource1.Servo90);
            smartPictureBox2.AddImageList(Resource1.Servo100);
            smartPictureBox2.AddImageList(Resource1.Servo110);
            smartPictureBox2.AddImageList(Resource1.Servo120);
            smartPictureBox2.AddImageList(Resource1.Servo130);
            smartPictureBox2.AddImageList(Resource1.Servo140);
            smartPictureBox2.AddImageList(Resource1.Servo150);
            smartPictureBox2.AddImageList(Resource1.Servo160);
            smartPictureBox2.AddImageList(Resource1.Servo170);
            smartPictureBox2.AddImageList(Resource1.Servo180);

            // SmartDraw2에 Servo0 이미지를 표시
            smartPictureBox2.DrawNext(0);

            // 0도 일때 DutyRate 96.3
            labPwm2Duty.Text = "96.3";
        }

        /// <summary>
        /// PWM1 Control (DC모터속도, 냉온소자온도 제어)
        /// </summary>

        // PWM1의 DutyRate를 +1 씩 증가
        private void btnPwm1DutyUp_Click(object sender, EventArgs e)
        {
            // 100이상 증가 안됨
            if (m_dbPWM1DutyRate < 100)
            {
                // m_dPWM1DutyRate 값 1씩 증가
                m_dbPWM1DutyRate++;

                // 레이블에 현재 듀티비 값 표시
                labPwm1Duty.Text = m_dbPWM1DutyRate.ToString();
            }

            // PWM1의 듀티비 적용
            smartPWM1.DutyRate1 = m_dbPWM1DutyRate;

            Pwm1DutyCheck();
        }

        // PWM1의 DutyRate를 +1 씩 감소
        private void btnPwm1DutyDown_Click(object sender, EventArgs e)
        {
            // 0이하 감소 안됨
            if (m_dbPWM1DutyRate >= 1)
            {
                // m_dPWM1DutyRate 값 1씩 감소
                m_dbPWM1DutyRate--;

                // 레이블에 현재 듀티비 값 표시
                labPwm1Duty.Text = m_dbPWM1DutyRate.ToString();
            }

            // PWM1의 듀티비 적용
            smartPWM1.DutyRate1 = m_dbPWM1DutyRate;

            Pwm1DutyCheck();
        }

        // PWM1의 DutyRate를 Level에 맞춰 설정
        private void btnPWM1Level_Click(object sender, EventArgs e)
        {
            if (sender == btnPwm1Lv1)
            {
                // Pwm1 DutyRate Value 20
                m_dbPWM1DutyRate = 20;
            }
            else if (sender == btnPwm1Lv2)
            {
                // Pwm1 DutyRate Value 40
                m_dbPWM1DutyRate = 40;
            }
            else if (sender == btnPwm1Lv3)
            {
                // Pwm1 DutyRate Value 60
                m_dbPWM1DutyRate = 60;
            }
            else if (sender == btnPwm1Lv4)
            {
                // Pwm1 DutyRate Value 80
                m_dbPWM1DutyRate = 80;
            }
            else
            {
                // Pwm1 DutyRate Value 100
                m_dbPWM1DutyRate = 100;
            }

            // PWM1의 듀티비 적용
            smartPWM1.DutyRate1 = m_dbPWM1DutyRate;
            // SmartLabel에 현재 듀티비 값을 표시
            labPwm1Duty.Text = smartPWM1.DutyRate1.ToString();
            // Level에 맞는 이미지 출력
            Pwm1DutyCheck();
        }

        // Pwm1 Duty값 체크해서 값에 따라서 이미지 변경
        private void Pwm1DutyCheck()
        {
            switch (m_dbPWM1DutyRate.ToString())
            {
                case "0":
                    // Lv0(DutyRate = 0)
                    smartPictureBox1.DrawNext(0);
                    break;
                case "20":
                    // Lv1(DutyRate = 20)
                    smartPictureBox1.DrawNext(1);
                    break;
                case "40":
                    // Lv2(DutyRate = 40)
                    smartPictureBox1.DrawNext(2);
                    break;
                case "60":
                    // Lv3(DutyRate = 60)
                    smartPictureBox1.DrawNext(3);
                    break;
                case "80":
                    // Lv4(DutyRate = 80)
                    smartPictureBox1.DrawNext(4);
                    break;
                case "100":
                    // Lv5(DutyRate = 100)
                    smartPictureBox1.DrawNext(5);
                    break;
            }
        }

        // PWM1의 PWM출력을 시작 / 정지한다.
        private void btnPwm1Start_Click(object sender, EventArgs e)
        {
            // PWM1 Start
            if (btnPwm1Start.ButtonStatus == SmartX.SmartButton.BUTSTATUS.DOWN)
            {
                smartPWM1.StartPWM1();
            }
            // PWM1 Stop
            else if (btnPwm1Start.ButtonStatus == SmartX.SmartButton.BUTSTATUS.UP)
            {
                smartPWM1.StopPWM1();

                // Pwm1 DutyRate Value 0
                m_dbPWM1DutyRate = 0;
                // PWM1의 듀티비 적용
                smartPWM1.DutyRate1 = m_dbPWM1DutyRate;
                // 레이블에 현재 듀티비 값 표시
                labPwm1Duty.Text = "0";
                Pwm1DutyCheck();

                // BtnPwm1Lv1 ~ BtnPwm1Lv5의 버튼을 누르기 전 상태로 유지
                btnPwm1Lv1.ButtonUp();
                btnPwm1Lv2.ButtonUp();
                btnPwm1Lv3.ButtonUp();
                btnPwm1Lv4.ButtonUp();
                btnPwm1Lv5.ButtonUp();
            }
        }

        /// <summary>
        /// PWM2 Control (Servo모터 각도제어)
        /// </summary>       

        // PWM2설정을 PreScale = 240, PwmCounter = 1381, ClockDivider = 1/4, DutyRate = 96.3 로설정

        // 0.5 ms = 97.3
        /// 0.7 ms = 96.3 (각도 0도)
        // 1.0 ms = 94.9
        /// 1.5 ms = 92.3 (각도 90도)
        // 2.0 ms = 89.9
        /// 2.3 ms = 88.4 (각도 180도)

        // Servo모터의 각도를 0˚도 제어
        private void btnServo0_Click(object sender, EventArgs e)
        {
            // PWM2의 듀티비 적용
            m_dbPWM2DutyRate = 96.3;
            smartPWM1.DutyRate2 = m_dbPWM2DutyRate;

            // SmartLabel에 현재 듀티비 값 표시
            labPwm2Duty.Text = string.Format("{0:0.0}", m_dbPWM2DutyRate).ToString();

            smartPictureBox2.DrawNext(0);
        }

        // Servo모터의 각도를 90˚도 제어
        private void btnServo90_Click(object sender, EventArgs e)
        {
            // PWM2의 듀티비 적용
            m_dbPWM2DutyRate = 92.3;
            smartPWM1.DutyRate2 = m_dbPWM2DutyRate;

            // 레이블에 현재 듀티비 값 표시
            labPwm2Duty.Text = string.Format("{0:0.0}", m_dbPWM2DutyRate).ToString();

            smartPictureBox2.DrawNext(9);
        }

        // Servo모터의 각도를 180˚도 제어
        private void btnServo180_Click(object sender, EventArgs e)
        {
            // PWM2의 듀티비 적용
            m_dbPWM2DutyRate = 88.4;
            smartPWM1.DutyRate2 = m_dbPWM2DutyRate;

            // 레이블에 현재 듀티비 값 표시
            labPwm2Duty.Text = string.Format("{0:0.0}", m_dbPWM2DutyRate).ToString();

            smartPictureBox2.DrawNext(18);
        }

        // PWM2 듀티비 증가 버튼 처리
        private void btnServoDutyUp_Click(object sender, EventArgs e)
        {
            // 96.3이상 증가 안됨
            if (m_dbPWM2DutyRate < 96.3)
            {
                // PWM2DutyRate 값 0.1씩 증가
                m_dbPWM2DutyRate += 0.1;

                // SmartLabel에 현재 듀티비 값 표시
                labPwm2Duty.Text = string.Format("{0:0.0}", m_dbPWM2DutyRate).ToString();
            }

            // PWM2의 듀티비 적용
            smartPWM1.DutyRate2 = m_dbPWM2DutyRate;

            Pwm2DutyCheck();
        }

        // PWM2 듀티비 감소 버튼 처리
        private void btnServoDutyDown_Click(object sender, EventArgs e)
        {
            // 88.4이하 감소 안됨
            if (m_dbPWM2DutyRate > 88.4)
            {
                // PWM2DutyRate 값 0.1씩 감소
                m_dbPWM2DutyRate -= 0.1;

                // 레이블에 현재 듀티비 값 표시
                labPwm2Duty.Text = string.Format("{0:0.0}", m_dbPWM2DutyRate).ToString();
            }

            // PWM2의 듀티비 적용
            smartPWM1.DutyRate2 = m_dbPWM2DutyRate;

            Pwm2DutyCheck();
        }

        // Pwm2 Duty값 체크해서 값에 따라서 이미지 변경
        private void Pwm2DutyCheck()
        {
            switch (string.Format("{0:0.0}", m_dbPWM2DutyRate).ToString())
            {
                case "96.3":
                    // 각도 0
                    smartPictureBox2.DrawNext(0);
                    break;
                case "95.9":
                    // 각도 10
                    smartPictureBox2.DrawNext(1);
                    break;
                case "95.4":
                    // 각도 20
                    smartPictureBox2.DrawNext(2);
                    break;
                case "95.0":
                    // 각도 30
                    smartPictureBox2.DrawNext(3);
                    break;
                case "94.5":
                    // 각도 40
                    smartPictureBox2.DrawNext(4);
                    break;
                case "94.1":
                    // 각도 50
                    smartPictureBox2.DrawNext(5);
                    break;
                case "93.6":
                    // 각도 60
                    smartPictureBox2.DrawNext(6);
                    break;
                case "93.2":
                    // 각도 70
                    smartPictureBox2.DrawNext(7);
                    break;
                case "92.7":
                    // 각도 80
                    smartPictureBox2.DrawNext(8);
                    break;
                case "92.3":
                    // 각도 90
                    smartPictureBox2.DrawNext(9);
                    break;
                case "92":
                    // 각도 100
                    smartPictureBox2.DrawNext(10);
                    break;
                case "91.5":
                    // 각도 110
                    smartPictureBox2.DrawNext(11);
                    break;
                case "91.1":
                    // 각도 120
                    smartPictureBox2.DrawNext(12);
                    break;
                case "90.6":
                    // 각도 130
                    smartPictureBox2.DrawNext(13);
                    break;
                case "90.2":
                    // 각도 140
                    smartPictureBox2.DrawNext(14);
                    break;
                case "89.7":
                    // 각도 150
                    smartPictureBox2.DrawNext(15);
                    break;
                case "89.3":
                    // 각도 160
                    smartPictureBox2.DrawNext(16);
                    break;
                case "88.8":
                    // 각도 170
                    smartPictureBox2.DrawNext(17);
                    break;
                case "88.4":
                    // 각도 180
                    smartPictureBox2.DrawNext(18);
                    break;
            }
        }

        // PWM2의 PWM출력을 시작 / 정지한다.
        private void btnPwm2Start_Click(object sender, EventArgs e)
        {
            // PWM2 Start
            if (btnPwm2Start.ButtonStatus == SmartX.SmartButton.BUTSTATUS.DOWN)
            {
                // PWM2의 듀티비, PWMCounter, ClockDiviert, Polarity 설정 변수선언 및 초기화
                m_dbPWM2DutyRate = 96.3;
                // PWM1, PWM2 초기 프리스케일러 설정
                smartPWM1.PreScaler = 240;
                // PWM2 초기 디바이더 설정
                smartPWM1.ClockDivider2 = SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE4;
                // PWM출력 비반전 처리
                smartPWM1.Polarity2 = SmartX.SmartPWM.POLARITY.HIGHACTIVE;
                // PWM2 Counter 초기 값 설정
                smartPWM1.PWMCounter2 = 1381;
                // PWM2 듀티비 초기 값 표시 및 설정
                smartPWM1.DutyRate2 = m_dbPWM2DutyRate;

                smartPWM1.StartPWM2();
            }
            // PWM2 Stop
            else if (btnPwm2Start.ButtonStatus == SmartX.SmartButton.BUTSTATUS.UP)
            {
                smartPWM1.StopPWM2();

                // PWM2의 듀티비 적용
                m_dbPWM2DutyRate = 96.3;
                smartPWM1.DutyRate2 = m_dbPWM2DutyRate;
                // 레이블에 현재 듀티비 값 표시
                labPwm2Duty.Text = string.Format("{0:0.0}", m_dbPWM2DutyRate).ToString();
                smartPictureBox2.DrawNext(0);

                btnServo0.ButtonUp();
                btnServo90.ButtonUp();
                btnServo180.ButtonUp();
            }
        }

        // PWM출력 반전/비반전 설정버튼
        private void btnPolarity_Click(object sender, EventArgs e)
        {
            if (btnPolarity.ButtonStatus == SmartX.SmartButton.BUTSTATUS.DOWN)
            {
                // PWM출력 비반전처리
                smartPWM1.Polarity2 = SmartX.SmartPWM.POLARITY.HIGHACTIVE;
                labPolarity.Text = "비반전";
            }
            else
            {
                // PWM출력 반전처리
                smartPWM1.Polarity2 = SmartX.SmartPWM.POLARITY.LOWACTIVE;
                labPolarity.Text = "반전";
            }
        }

        private void smartUpDown1_OnDownButtonClick(object sender, EventArgs e)
        {
            Frequence_Parsing(smartUpDown1.ValueItems);
        }

        private void smartUpDown1_OnUpButtonClick(object sender, EventArgs e)
        {
            Frequence_Parsing(smartUpDown1.ValueItems);
        }

        // 주파수 설정 파싱함수
        private void Frequence_Parsing(string v_Frequence)
        {
            switch (v_Frequence)
            {
                case "1K":
                    smartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 16632);
                    break;
                case "2K":
                    smartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 8320);
                    break;
                case "5K":
                    smartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 3325);
                    break;
                case "10K":
                    smartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 1660);
                    break;
                case "20K":
                    smartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 830);
                    break;
                case "50K":
                    smartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 331);
                    break;
                case "100K":
                    smartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 164);
                    break;
                case "200K":
                    smartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 82);
                    break;
                case "500K":
                    smartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 32);
                    break;
                case "1M":
                    smartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 15);
                    break;
                case "2M":
                    smartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 7);
                    break;
                case "8M":
                    smartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 1);
                    break;
                case "11M":
                    smartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE1, 1, 2);
                    break;
                case "16M":
                    smartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE1, 1, 1);
                    break;
            }
        }
    }
}