﻿Imports TechNote54_SmartIO_PWM_VB.My.Resources

Public Class Form1

    ' IEC667, IEC1000-Series  설정가능한 주파수 배열
    Private m_Frequence As String() = {"1K", "2K", "5K", "10K", "20K", "50K", "100K", "200K", "500K", "1M", "2M", "8M", "11M", "16M"}
    ' PWM2의 듀티비 설정 변수선언
    Private m_dbPWM2DutyRate As Double
    ' PWM1의 듀티비 설정 변수선언
    Private m_dbPWM1DutyRate As Double

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        ' 현재 Form을 MainForm으로 설정합니다.
        SmartForm1.MainForm = Me

        ' 멤버변수 초기화
        m_dbPWM1DutyRate = 0
        m_dbPWM2DutyRate = 96.3

        smartUpDown1.Items = m_Frequence.ToList()

        ' PWM1, PWM2 초기 프리스케일러 설정
        SmartPWM1.PreScaler = 240

        ' PWM1, PWM2 초기 디바이더 설정
        SmartPWM1.ClockDivider1 = SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2
        SmartPWM1.ClockDivider2 = SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE4

        ' PWM출력 비반전 처리
        SmartPWM1.Polarity1 = SmartX.SmartPWM.POLARITY.HIGHACTIVE
        SmartPWM1.Polarity2 = SmartX.SmartPWM.POLARITY.HIGHACTIVE

        ' PWM1, PWM2 Counter 초기 값 설정
        SmartPWM1.PWMCounter1 = 200
        SmartPWM1.PWMCounter2 = 1381

        ' PWM1, PWM2 듀디비 초기 값 표시 및 설정
        labPwm1Duty.Text = m_dbPWM1DutyRate.ToString()
        SmartPWM1.DutyRate1 = m_dbPWM1DutyRate
        SmartPWM1.DutyRate2 = m_dbPWM2DutyRate

        ' PWM1 & PWM2 DeadTime 초기 값 표시 및 설정 
        SmartPWM1.DeadTime = 0

        ' Pwm1 gauge 이미지를 내부 리스트에 추가한다.
        smartPictureBox1.AddImageList(Resource1.Lv0)
        smartPictureBox1.AddImageList(Resource1.Lv1)
        smartPictureBox1.AddImageList(Resource1.Lv2)
        smartPictureBox1.AddImageList(Resource1.Lv3)
        smartPictureBox1.AddImageList(Resource1.Lv4)
        smartPictureBox1.AddImageList(Resource1.Lv5)

        ' SmartPictureBox1에 Lv0 이미지를 표시
        smartPictureBox1.DrawNext(0)

        ' Pwm2 Servo 각도이미지를 내부 리스트에 추가
        smartPictureBox2.AddImageList(Resource1.Servo0)
        smartPictureBox2.AddImageList(Resource1.Servo10)
        smartPictureBox2.AddImageList(Resource1.Servo20)
        smartPictureBox2.AddImageList(Resource1.Servo30)
        smartPictureBox2.AddImageList(Resource1.Servo40)
        smartPictureBox2.AddImageList(Resource1.Servo50)
        smartPictureBox2.AddImageList(Resource1.Servo60)
        smartPictureBox2.AddImageList(Resource1.Servo70)
        smartPictureBox2.AddImageList(Resource1.Servo80)
        smartPictureBox2.AddImageList(Resource1.Servo90)
        smartPictureBox2.AddImageList(Resource1.Servo100)
        smartPictureBox2.AddImageList(Resource1.Servo110)
        smartPictureBox2.AddImageList(Resource1.Servo120)
        smartPictureBox2.AddImageList(Resource1.Servo130)
        smartPictureBox2.AddImageList(Resource1.Servo140)
        smartPictureBox2.AddImageList(Resource1.Servo150)
        smartPictureBox2.AddImageList(Resource1.Servo160)
        smartPictureBox2.AddImageList(Resource1.Servo170)
        smartPictureBox2.AddImageList(Resource1.Servo180)

        ' SmartDraw2에 Servo0 이미지를 표시
        smartPictureBox2.DrawNext(0)

        ' 0도 일때 DutyRate 96.3
        labPwm2Duty.Text = "96.3"
    End Sub

    ' <summary>
    ' PWM1 Control (DC모터속도, 냉온소자온도 제어)
    ' </summary>

    ' PWM1의 DutyRate를 +1 씩 증가
    Private Sub btnPwm1DutyUp_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnPwm1DutyUp.Click
        ' 100이상 증가 안됨
        If m_dbPWM1DutyRate < 100 Then
            ' m_dPWM1DutyRate 값 1씩 증가
            m_dbPWM1DutyRate += 1

            ' 레이블에 현재 듀티비 값 표시
            labPwm1Duty.Text = m_dbPWM1DutyRate.ToString()
        End If

        ' PWM1의 듀티비 적용
        SmartPWM1.DutyRate1 = m_dbPWM1DutyRate

        Pwm1DutyCheck()
    End Sub

    ' PWM1의 DutyRate를 +1 씩 감소
    Private Sub btnPwm1DutyDown_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnPwm1DutyDown.Click
        ' 0이하 감소 안됨
        If m_dbPWM1DutyRate >= 1 Then
            ' m_dPWM1DutyRate 값 1씩 감소
            m_dbPWM1DutyRate -= 1

            ' 레이블에 현재 듀티비 값 표시
            labPwm1Duty.Text = m_dbPWM1DutyRate.ToString()
        End If

        ' PWM1의 듀티비 적용
        SmartPWM1.DutyRate1 = m_dbPWM1DutyRate

        Pwm1DutyCheck()
    End Sub

    ' PWM1의 DutyRate를 Level에 맞춰 설정
    Private Sub btnPWM1Level_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnPwm1Lv5.Click, btnPwm1Lv4.Click, btnPwm1Lv3.Click, btnPwm1Lv2.Click, btnPwm1Lv1.Click
        If sender Is btnPwm1Lv1 Then
            ' Pwm1 DutyRate Value 20
            m_dbPWM1DutyRate = 20
        ElseIf sender Is btnPwm1Lv2 Then
            ' Pwm1 DutyRate Value 40
            m_dbPWM1DutyRate = 40
        ElseIf sender Is btnPwm1Lv3 Then
            ' Pwm1 DutyRate Value 60
            m_dbPWM1DutyRate = 60
        ElseIf sender Is btnPwm1Lv4 Then
            ' Pwm1 DutyRate Value 80
            m_dbPWM1DutyRate = 80
        Else
            ' Pwm1 DutyRate Value 100
            m_dbPWM1DutyRate = 100
        End If

        ' PWM1의 듀티비 적용
        SmartPWM1.DutyRate1 = m_dbPWM1DutyRate
        ' SmartLabel에 현재 듀티비 값을 표시
        labPwm1Duty.Text = SmartPWM1.DutyRate1.ToString()
        ' Level에 맞는 이미지 출력
        Pwm1DutyCheck()
    End Sub

    ' Pwm1 Duty값 체크해서 값에 따라서 이미지 변경
    Private Sub Pwm1DutyCheck()
        Select Case m_dbPWM1DutyRate.ToString()
            Case "0"
                ' Lv0(DutyRate = 0)
                smartPictureBox1.DrawNext(0)
            Case "20"
                ' Lv1(DutyRate = 20)
                smartPictureBox1.DrawNext(1)
            Case "40"
                ' Lv2(DutyRate = 40)
                smartPictureBox1.DrawNext(2)
            Case "60"
                ' Lv3(DutyRate = 60)
                smartPictureBox1.DrawNext(3)
            Case "80"
                ' Lv4(DutyRate = 80)
                smartPictureBox1.DrawNext(4)
            Case "100"
                ' Lv5(DutyRate = 100)
                smartPictureBox1.DrawNext(5)
        End Select
    End Sub

    ' PWM1의 PWM출력을 시작 / 정지한다.
    Private Sub btnPwm1Start_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnPwm1Start.Click
        If btnPwm1Start.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN Then
            ' PWM1 Start
            SmartPWM1.StartPWM1()
        ElseIf btnPwm1Start.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            ' PWM1 Stop
            SmartPWM1.StopPWM1()

            ' Pwm1 DutyRate Value 0
            m_dbPWM1DutyRate = 0
            ' PWM1의 듀티비 적용
            SmartPWM1.DutyRate1 = m_dbPWM1DutyRate
            ' 레이블에 현재 듀티비 값 표시
            labPwm1Duty.Text = "0"
            Pwm1DutyCheck()

            ' BtnPwm1Lv1 ~ BtnPwm1Lv5의 버튼을 누르기 전 상태로 유지
            btnPwm1Lv1.ButtonUp()
            btnPwm1Lv2.ButtonUp()
            btnPwm1Lv3.ButtonUp()
            btnPwm1Lv4.ButtonUp()
            btnPwm1Lv5.ButtonUp()
        End If
    End Sub

    ' <summary>
    ' PWM2 Control (Servo모터 각도제어)
    ' </summary>       

    ' PWM2설정을 PreScale = 240, PwmCounter = 1381, ClockDivider = 1/4, DutyRate = 96.3 로설정

    ' 0.5 ms = 97.3
    ' 0.7 ms = 96.3 (각도 0도)
    ' 1.0 ms = 94.9
    ' 1.5 ms = 92.3 (각도 90도)
    ' 2.0 ms = 89.9
    ' 2.3 ms = 88.4 (각도 180도)

    ' Servo모터의 각도를 0˚도 제어
    Private Sub btnServo0_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnServo0.Click
        ' PWM2의 듀티비 적용
        m_dbPWM2DutyRate = 96.3
        SmartPWM1.DutyRate2 = m_dbPWM2DutyRate

        ' SmartLabel에 현재 듀티비 값 표시
        labPwm2Duty.Text = String.Format("{0:0.0}", m_dbPWM2DutyRate).ToString()

        smartPictureBox2.DrawNext(0)
    End Sub

    ' Servo모터의 각도를 90˚도 제어
    Private Sub btnServo90_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnServo90.Click
        ' PWM2의 듀티비 적용
        m_dbPWM2DutyRate = 92.3
        SmartPWM1.DutyRate2 = m_dbPWM2DutyRate

        ' 레이블에 현재 듀티비 값 표시
        labPwm2Duty.Text = String.Format("{0:0.0}", m_dbPWM2DutyRate).ToString()

        smartPictureBox2.DrawNext(9)
    End Sub

    ' Servo모터의 각도를 180˚도 제어
    Private Sub btnServo180_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnServo180.Click
        ' PWM2의 듀티비 적용
        m_dbPWM2DutyRate = 88.4
        SmartPWM1.DutyRate2 = m_dbPWM2DutyRate

        ' 레이블에 현재 듀티비 값 표시
        labPwm2Duty.Text = String.Format("{0:0.0}", m_dbPWM2DutyRate).ToString()

        smartPictureBox2.DrawNext(18)
    End Sub

    ' PWM2 듀티비 증가 버튼 처리
    Private Sub btnServoDutyUp_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnServoDutyUp.Click
        ' 96.3이상 증가 안됨
        If m_dbPWM2DutyRate < 96.3 Then
            ' PWM2DutyRate 값 0.1씩 증가
            m_dbPWM2DutyRate += 0.1

            ' SmartLabel에 현재 듀티비 값 표시
            labPwm2Duty.Text = String.Format("{0:0.0}", m_dbPWM2DutyRate).ToString()
        End If

        ' PWM2의 듀티비 적용
        SmartPWM1.DutyRate2 = m_dbPWM2DutyRate

        Pwm2DutyCheck()
    End Sub

    ' PWM2 듀티비 감소 버튼 처리
    Private Sub btnServoDutyDown_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnServoDutyDown.Click
        ' 88.4이하 감소 안됨
        If m_dbPWM2DutyRate > 88.4 Then
            ' PWM2DutyRate 값 0.1씩 감소
            m_dbPWM2DutyRate -= 0.1

            ' 레이블에 현재 듀티비 값 표시
            labPwm2Duty.Text = String.Format("{0:0.0}", m_dbPWM2DutyRate).ToString()
        End If

        ' PWM2의 듀티비 적용
        SmartPWM1.DutyRate2 = m_dbPWM2DutyRate

        Pwm2DutyCheck()
    End Sub

    ' Pwm2 Duty값 체크해서 값에 따라서 이미지 변경
    Private Sub Pwm2DutyCheck()
        Select Case String.Format("{0:0.0}", m_dbPWM2DutyRate).ToString()
            Case "96.3"
                ' 각도 0
                smartPictureBox2.DrawNext(0)
            Case "95.9"
                ' 각도 10
                smartPictureBox2.DrawNext(1)
            Case "95.4"
                ' 각도 20
                smartPictureBox2.DrawNext(2)
            Case "95.0"
                ' 각도 30
                smartPictureBox2.DrawNext(3)
            Case "94.5"
                ' 각도 40
                smartPictureBox2.DrawNext(4)
            Case "94.1"
                ' 각도 50
                smartPictureBox2.DrawNext(5)
            Case "93.6"
                ' 각도 60
                smartPictureBox2.DrawNext(6)
            Case "93.2"
                ' 각도 70
                smartPictureBox2.DrawNext(7)
            Case "92.7"
                ' 각도 80
                smartPictureBox2.DrawNext(8)
            Case "92.3"
                ' 각도 90
                smartPictureBox2.DrawNext(9)
            Case "92"
                ' 각도 100
                smartPictureBox2.DrawNext(10)
            Case "91.5"
                ' 각도 110
                smartPictureBox2.DrawNext(11)
            Case "91.1"
                ' 각도 120
                smartPictureBox2.DrawNext(12)
            Case "90.6"
                ' 각도 130
                smartPictureBox2.DrawNext(13)
            Case "90.2"
                ' 각도 140
                smartPictureBox2.DrawNext(14)
            Case "89.7"
                ' 각도 150
                smartPictureBox2.DrawNext(15)
            Case "89.3"
                ' 각도 160
                smartPictureBox2.DrawNext(16)
            Case "88.8"
                ' 각도 170
                smartPictureBox2.DrawNext(17)
            Case "88.4"
                ' 각도 180
                smartPictureBox2.DrawNext(18)
        End Select
    End Sub

    ' PWM2의 PWM출력을 시작 / 정지한다.
    Private Sub btnPwm2Start_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnPwm2Start.Click
        If btnPwm2Start.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN Then
            ' PWM2 Start
            ' PWM2의 듀티비, PWMCounter, ClockDiviert, Polarity 설정 변수선언 및 초기화
            m_dbPWM2DutyRate = 96.3
            ' PWM1, PWM2 초기 프리스케일러 설정
            SmartPWM1.PreScaler = 240
            ' PWM2 초기 디바이더 설정
            SmartPWM1.ClockDivider2 = SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE4
            ' PWM출력 비반전 처리
            SmartPWM1.Polarity2 = SmartX.SmartPWM.POLARITY.HIGHACTIVE
            ' PWM2 Counter 초기 값 설정
            SmartPWM1.PWMCounter2 = 1381
            ' PWM2 듀티비 초기 값 표시 및 설정
            SmartPWM1.DutyRate2 = m_dbPWM2DutyRate

            SmartPWM1.StartPWM2()
        ElseIf btnPwm2Start.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            ' PWM2 Stop
            SmartPWM1.StopPWM2()

            ' PWM2의 듀티비 적용
            m_dbPWM2DutyRate = 96.3
            SmartPWM1.DutyRate2 = m_dbPWM2DutyRate
            ' 레이블에 현재 듀티비 값 표시
            labPwm2Duty.Text = String.Format("{0:0.0}", m_dbPWM2DutyRate).ToString()
            smartPictureBox2.DrawNext(0)

            btnServo0.ButtonUp()
            btnServo90.ButtonUp()
            btnServo180.ButtonUp()
        End If
    End Sub

    ' PWM출력 반전/비반전 설정버튼
    Private Sub btnPolarity_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnPolarity.Click
        If btnPolarity.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN Then
            ' PWM출력 비반전처리
            SmartPWM1.Polarity2 = SmartX.SmartPWM.POLARITY.HIGHACTIVE
            labPolarity.Text = "비반전"
        Else
            ' PWM출력 반전처리
            SmartPWM1.Polarity2 = SmartX.SmartPWM.POLARITY.LOWACTIVE
            labPolarity.Text = "반전"
        End If
    End Sub

    Private Sub smartUpDown1_OnDownButtonClick(ByVal sender As Object, ByVal e As EventArgs) Handles smartUpDown1.OnDownButtonClick
        Frequence_Parsing(smartUpDown1.ValueItems)
    End Sub

    Private Sub smartUpDown1_OnUpButtonClick(ByVal sender As Object, ByVal e As EventArgs) Handles smartUpDown1.OnUpButtonClick
        Frequence_Parsing(smartUpDown1.ValueItems)
    End Sub

    ' 주파수 설정 파싱함수
    Private Sub Frequence_Parsing(ByVal v_Frequence As String)
        Select Case v_Frequence
            Case "1K"
                SmartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 16632)
            Case "2K"
                SmartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 8320)
            Case "5K"
                SmartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 3325)
            Case "10K"
                SmartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 1660)
            Case "20K"
                SmartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 830)
            Case "50K"
                SmartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 331)
            Case "100K"
                SmartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 164)
            Case "200K"
                SmartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 82)
            Case "500K"
                SmartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 32)
            Case "1M"
                SmartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 15)
            Case "2M"
                SmartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 7)
            Case "8M"
                SmartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 1, 1)
            Case "11M"
                SmartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE1, 1, 2)
            Case "16M"
                SmartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE1, 1, 1)
        End Select
    End Sub
End Class
